var gDoneButton; 
var gInfoButton; 

var lowestNote = 12;
var highestNote = 63;

var isPlayable = false;

function showPrefs() 
{ 
	var front = document.getElementById("front"); 
	var back = document.getElementById("back"); 
	if (window.widget) 
		widget.prepareForTransition("ToBack");
	front.className = "back";
	////front.style.display="none"; 
	back.style.display="block";
	hideKeys();


	if (window.TastieraPlugIn && TastieraPlugIn.isDemo()) {
		var demo = true;
	} else {
		var demo = false;
	}
	
	var strumenti1 = "";
	for (i = 0; i < 128; i++) {
		if (i%8 == 0) strumenti1 += '<optgroup label="' + famiglia[i/8] + '">';
		strumenti1 += "<option" + (demo && i%8 ? " disabled" : "") + ">" + (i+1) + ". " + strumento[i];
		if (i%8 == 7) strumenti1 += '</optgroup>';
	}
	var strumenti2 = "";
	for (i = 0; i < 128; i++) {
		if (i%8 == 0) strumenti2 += '<optgroup label="' + famiglia[i/8] + '">';
		strumenti2 += "<option" + (demo && i!=0 ? " disabled" : "") + ">" + (i+1) + ". " + strumento[i];
		if (i%8 == 7) strumenti2 += '</optgroup>';
	}

	var strumento1 = document.getElementById("strumento1");
	strumento1.innerHTML = strumenti1;
	strumento1.selectedIndex = instrument1;

	var strumento2 = document.getElementById("strumento2");
	strumento2.innerHTML = strumenti2;
	strumento2.selectedIndex = instrument2;

	function notelist(first, last, cond) {
		var list = "";
		if (first%7 != octaveStartsAt)
			list += "<optgroup label='" + ottava[(first-octaveStartsAt-(first-octaveStartsAt)%7)/7] + "'>";
		for (i = first; i <= last; i++) {
			if (i%7 == octaveStartsAt) list += "<optgroup label='" + ottava[(i-octaveStartsAt)/7] + "'>";
			list += "<option" + (demo && eval(cond) ? " disabled" : "") + ">" + nomeDellaNota(i);
			if (i%7 == (octaveStartsAt-1)%7) list += "</optgroup>";
		}
		if (last%7 != (octaveStartsAt-1)%7) list += "</optgroup>";
		return list; 
	}


	range1start = document.getElementById("range1start");
	range1end = document.getElementById("range1end");
	range2start = document.getElementById("range2start");
	range2end = document.getElementById("range2end");
	
	range1start.innerHTML = notelist(lowestNote, highestNote-11, "i!=35");
	range1end.innerHTML = notelist(lowestNote+11, highestNote, "i-11!=35");
	range2start.innerHTML =notelist(lowestNote, highestNote-10, "i%5");
	range2end.innerHTML = notelist(lowestNote+10, highestNote, "i%5"); // <=> (i-10)%5
	
	range1start.selectedIndex = base1-lowestNote;
	range1end.selectedIndex = base1-lowestNote;
	range2start.selectedIndex = base2-lowestNote;
	range2end.selectedIndex = base2-lowestNote;


	document.getElementById("doremi").innerHTML =
	 "<option value=0>" + txt.qwerty +
	 "<option value=1>" + txt.doremi;
	document.getElementById("doremi").selectedIndex = doremi;

	if (demo)
		document.getElementById("licensee").innerHTML = "";
	else
		document.getElementById("licensee").innerHTML = txt.licensee + TastieraPlugIn.getLicensee();

	if (window.widget) 
		setTimeout ('widget.performTransition();', 0);  
} 

function hidePrefs() 
{ 
	var front = document.getElementById("front"); 
	var back = document.getElementById("back"); 
	if (window.widget) 
		widget.prepareForTransition("ToFront"); 
	back.style.display="none"; 
	front.className = "";
	////front.style.display="block"; 
	if (isPlayable) {
		showKeys();
	}
	if (window.widget) 
		setTimeout ('widget.performTransition();', 0); 
} 

window.onload = function()
{
	//document.getElementById("textbox").onkeypress = tast;
	//document.onkeypress = press;
	document.onkeyup = up;
	document.onkeydown = down;


	gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), 
txt["done"], hidePrefs); 
	gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), 
document.getElementById("front"), "white", "white", showPrefs); 

}

window.onfocus = focus; 
window.onblur = blur;
//window.onunload = event; // never fires


ASCIItoKey = [ // not quite ASCII for symbols (close to ASCII+128)
	  ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,
	  ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,
	  ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,
	29, 18, 19, 20, 21, 23, 22, 26, 28, 25,   ,   ,   ,   ,   ,   ,
	  ,  0, 11,  8,  3, 14,  4,  6,  5, 34, 38, 40, 37, 46, 45, 31,
	35, 11, 15,  1, 17, 32,  9, 13,  7, 16,  6,   ,   ,   ,   ,   ,
	  ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,
	  ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,
	  ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,
	  ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,
	  ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,
	  ,   ,   ,   ,   ,   ,   ,   ,   ,   , 41, 24, 43, 27, 47, 44,
	50,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,
	  ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   , 33, 42, 30, 39,   ,
	  ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,
	  ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,
]


//var base1 = 25;
var base2;
var instrument2;

var keyboard2 = {
	50:0, 6:1, 7:2, 8:3, 9:4, 11:5, 45:6, 46:7, 43:8, 47:9, 44:10,
	0:0.5, 1:1.5, 2:2.5, 3:3.5, 5:4.5, 4:5.5, 38:6.5, 40:7.5, 37:8.5,
		41:9.5, 39:10.5 /*, 42:11.5*/
};

//var base2 = 35;
var base1;
var instrument1;

var keyboard1 = {
	12:0, 13:1, 14:2, 15:3, 17:4, 16:5, 32:6, 34:7, 31:8, 35:9, 33:10, 30:11,
	/*10:-1.5,*/ 18:-0.5, 19:0.5, 20:1.5, 21:2.5, 23:3.5, 22:4.5, 26:5.5, 28:6.5,
		25:7.5, 29:8.5, 27:9.5, 24:10.5
};

var doremi; // false: QWERTY,  true: Do-Re-Mi / CDEFGABC

var keys = new Array();

var charToKey = new Array();

var isdown = new Array;

function down(e)
{
	//var s = document.getElementById("tast").innerHTML;
	//s += "down " + String.fromCharCode(e.charCode) + "<br>";
	//document.getElementById("tast").innerHTML = s;
	e.preventDefault();
	var c;
	if (id = e.keyIdentifier.match(/U\+([0-9A-F]+)/))
		//window.console.log("«" + parseInt(id[1],16) +"»");
		c = charToKey[parseInt(id[1],16)];
	else
		c = ASCIItoKey[e.keyCode];
	//window.console.log("«" + c +"» ");
	if (isdown[c]) return false;
	isdown[c] = true;
	//window.console.log(" `" + c + "'");
	var elt = document.getElementById(c);
	if (elt) /*elt.style.borderColor = "red";*/ elt.className = "btn pressed";

	var accord = -1;

	if (c in keyboard1) {
		var n = base1 + keyboard1[c];
		if (n % 7 % 4 !== 2.5) {
			n = Math.round((12*n + 2)/7);
			if (window.TastieraPlugIn)
				//TastieraPlugIn.down(n, 0);
				accord = TastieraPlugIn.down(n, 0);
			//alert("accord: " + accord + " " + (accord>>12) + "-" + (accord&0xFFF));
            if ((accord&0xFFF) in accordo) {
                var acc = accordo[accord&0xFFF];
                //alert(fondamentale[acc[0]][((accord>>12)+acc[1])%12] + acc[2]);
                document.getElementById("chord1").innerHTML = fondamentale[acc[0]][((accord>>12)+acc[1])%12] + acc[2];
                //document.getElementById("chord2").children[0].innerHTML = acc[3];
                document.getElementById("chord2").innerHTML = acc[3];
            } else {
                document.getElementById("chord1").innerHTML = '';
                document.getElementById("chord2").innerHTML = '';
            }
			//var aa = bb;
			//FortunePlugin.down1(n);
		}
	} else if (c in keyboard2) {
		var n = base2 + keyboard2[c];
		if (n % 7 % 4 !== 2.5) {
			n = Math.round((12*n + 2)/7);
			if (window.TastieraPlugIn)
				//TastieraPlugIn.down(n, 1);
				accord = TastieraPlugIn.down(n, 1);
			//alert("accord: " + accord + " " + (accord>>12) + "-" + (accord&0xFFF));
            if ((accord&0xFFF) in accordo) {
                var acc = accordo[accord&0xFFF];
                //alert(fondamentale[acc[0]][((accord>>12)+acc[1])%12] + acc[2]);
                document.getElementById("chord1").innerHTML = fondamentale[acc[0]][((accord>>12)+acc[1])%12] + acc[2];
                //document.getElementById("chord2").children[0].innerHTML = acc[3];
                document.getElementById("chord2").innerHTML = acc[3];
            } else {
                document.getElementById("chord1").innerHTML = '';
                document.getElementById("chord2").innerHTML = '';            
            }
			//FortunePlugin.logMessage(n);
			////FortunePlugin.down1(n);
		}
	}
}

function up(e)
{
	//var s = document.getElementById("tast").innerHTML;
	//s += "up " + String.fromCharCode(e.charCode) + '<br>';
	//document.getElementById("tast").innerHTML = s;
	e.preventDefault();
	//var c = e.keyCode;
	var c;
	if (id = e.keyIdentifier.match(/U\+([0-9A-F]+)/))
		//window.console.log("«" + parseInt(id[1],16) +"»");
		c = charToKey[parseInt(id[1],16)];
	else
		c = ASCIItoKey[e.keyCode];
	isdown[c] = false;

	var elt = document.getElementById(c);
	if (elt) /*elt.style.borderColor = "gray";*/ elt.className = "btn";

	if (c in keyboard1) {
		var n = base1 + keyboard1[c];
		if (n % 7 % 4 !== 2.5) {
			n = Math.round((12*n + 2)/7);
			if (window.TastieraPlugIn)
				TastieraPlugIn.up(n, 0);
			//FortunePlugin.logMessage(n);
			//FortunePlugin.up1(n);
            document.getElementById("chord1").innerHTML = '';
            document.getElementById("chord2").innerHTML = '';
		}
	} else if (c in keyboard2) {
		var n = base2 + keyboard2[c];
		if (n % 7 % 4 !== 2.5) {
			n = Math.round((12*n + 2)/7);
			if (window.TastieraPlugIn)
				TastieraPlugIn.up(n, 1);
			//FortunePlugin.logMessage(n);
			//FortunePlugin.up1(n);
            document.getElementById("chord1").innerHTML = '';
            document.getElementById("chord2").innerHTML = '';
		}
	}

}


function progchange1(instr)
{
	//window.console.log("Prog: " + instr);	
	if (window.TastieraPlugIn)
		TastieraPlugIn.progChange(instr, 0);
	instrument1 = instr;
	if (window.widget)
		widget.setPreferenceForKey(instrument1, "instrument1");
	//alert(instr);
}

function progchange2(instr)
{
	//window.console.log("Prog: " + instr);	
	if (window.TastieraPlugIn)
		TastieraPlugIn.progChange(instr, 1);
	instrument2 = instr;
	if (window.widget)
		widget.setPreferenceForKey(instrument2, "instrument2");
	//alert(instr);
}


function rangechange1(n)
{
	base1 = n+lowestNote;
	if (window.widget)
		widget.setPreferenceForKey(base1, "base1");
	//alert(instr);
}

function rangechange2(n)
{
	base2 = n+lowestNote;
	if (window.widget)
		widget.setPreferenceForKey(base2, "base2");
	//alert(instr);
}

function setdoremi(x)
{
	doremi = x;
	if (window.widget)
		widget.setPreferenceForKey(doremi, "doremi");
}

function focus() {
	isPlayable = false;
	//clearResults();
	//updateControl(document.getElementById("today"));

	if (window.widget) {
		base1 = widget.preferenceForKey("base1");
		base2 = widget.preferenceForKey("base2");
		instrument1 = widget.preferenceForKey("instrument1");
		instrument2 = widget.preferenceForKey("instrument2");
		doremi = widget.preferenceForKey("doremi");
		
	}

	if (window.TastieraPlugIn) {
		//showError("Starting synth...")
		var res = TastieraPlugIn.startSynth();
		if (res == 8) {
		  showError("<a style='cursor:hand' href='#' title='" + txt.register + "' onclick='widget.openURL(\"http://coq.no/widget/tastiera/en\");'>" + txt.expired + "</a>");
		  return false;
		} else if (res != 0) {
		  showError(txt.errornumber + res);
		  return false;
		}

		if (base1 == null) rangechange1(35-lowestNote);
		if (base2 == null) rangechange2(25-lowestNote);

		if (TastieraPlugIn.isDemo()) {
			// fix corrupted prefs (should not be necessary):
			base1 = 35;
			base2 -= base2 % 5;
			instrument1 -= instrument1 % 8;
			instrument2 = 0;
		}
		
		TastieraPlugIn.progChange(instrument1, 0);
		TastieraPlugIn.progChange(instrument2, 1);
		keys = TastieraPlugIn.keyboard();
		charToKey = [];
		for (var i = 0; i <= 50; i++) {
			//window.console.log(keys[i])
			charToKey[keys[i].charCodeAt(0)] = i;
			// add ASCII uppercase
			if (/^[a-z]$/.test(keys[i]))
				charToKey[keys[i].charCodeAt(0)-32] = i;
		}
		/*if (!keys || keys.length==0) {
			showError(DAY_ERR);
		} else {
			showContent(buildResultsTable(bdays));
			keys = ["qq", "ss", "dd", "ff", "kk"];
		}*/
	} else {
		showError("plug-in error");
		//keys = ["q", "s", "d", "f", "k"];
	}
	//window.console.log("hhello world " + keys[0] + keys[1] + " .." + keys.length);
	//if (back.style.display != "block")
	isPlayable = true;	
	showKeys();
	if (window.TastieraPlugIn && TastieraPlugIn.isDemo()) {
		showError("<a style='cursor:hand' href='#' title='" + txt.register + "' onclick='widget.openURL(\"http://coq.no/widget/tastiera/en\");'>" + txt.demo + "</a>");
	} else {
		 hideError();			
	}

} 


function blur() {
	//window.console.log("blur");
	if (window.TastieraPlugIn)
		TastieraPlugIn.stopSynth();
	hideKeys();
		//else window.console.log("nopi");
	hideError();
	document.getElementById("back").style.display="none"; 
	document.getElementById("front").className = "";
}

function hideKeys() {
	for (var i = 0; i <= 50; i++) {
		var elt = document.getElementById(i);
		//window.console.log("ho " + i);
		if (elt) {
			elt.innerText = "";
			elt.style.visibility = "visible";
		}
	}
}

function showKeys() {
	for (var i = 0; i <= 50; i++) {
		var elt = document.getElementById(i);
		//window.console.log("nº " + i + "--" + JSKeyCode[i] + " ‘" +  keys[i] + "’");
		if (elt) {
			if (!doremi) // QWERTY
				if (/^[ςß]$/.test(keys[i])) // final sigma and double s
					elt.innerText = keys[i];
				else
					elt.innerText = keys[i].toUpperCase();
			if (i in keyboard1) {
				var n = base1 + keyboard1[i];
				if (n % 7 % 4 === 2.5) {
					elt.style.visibility = "hidden";
				} else if (doremi && n % 1 == 0) {
					elt.innerText = nota[n % 7];
				}
			} else if (i in keyboard2) {
				var n = base2 + keyboard2[i];
				if (n % 7 % 4 === 2.5) {
					elt.style.visibility = "hidden";
				} else if (doremi && n % 1 == 0) {
					elt.innerText = nota[n % 7];
				}
			}
				
			//FortunePlugin.logMessage(n);
			//FortunePlugin.up1(n);
		}
	}
}

function event(e) {
	window.console.log("Event: " + e.type);
}


function showError(error) {
	var errorDiv = document.getElementById("errorDiv");
	/*if (errorDiv.firstChild) {
		errorDiv.removeChild(errorDiv.firstChild);
	}
	errorDiv.appendChild(document.createTextNode(error));*/
	errorDiv.innerHTML = error;
	errorDiv.className = "KO";
	//errorDiv.style.display = "block";
	
}

function hideError() {
	//document.getElementById("errorDiv").style.display = "none";
	errorDiv.className = "OK";
}



accordo = {
    // M
    72: ["M", 0, "", ""],
    132: ["M", 8, "", "6"],
    272: ["M", 5, "", "46"],
    // m
    68: ["m", 0, "", ""],
    264: ["m", 9, "", "6"],
    144: ["m", 5, "", "46"],
    // ○
    36: ["m", 0, "○", ""],
    260: ["m", 9, "○", "6"],
    288: ["m", 6, "○", "46"],
    // ′
    136: ["M", 0, "′", ""],
    // M7
    584: ["M", 0, "", "7"],
    164: ["M", 8, "", "56"],
    276: ["M", 5, "", "34"],
    290: ["M", 2, "", "2"],
    // m7
    580: ["m", 0, "", "7"],
    328: ["m", 9, "", "56"],
    148: ["m", 5, "", "34"],
    274: ["m", 2, "", "2"],
    // ⌀7
    548: ["m", 0, "⌀", "7"],
    324: ["m", 9, "⌀", "56"],
    296: ["m", 6, "⌀", "34"],
    146: ["m", 2, "⌀", "2"],
    // M△7
    1096: ["M", 0, "△", "7"],
    196: ["M", 8, "△", "56"],
    280: ["M", 5, "△", "34"],
    145: ["M", 1, "△", "2"],
    // ○7
    292: ["m", 0, "○", "7"],
    // m△7
    1092: ["m", 0, "△", "7"],
    392: ["m", 9, "△", "56"],
    152: ["m", 5, "△", "34"],
    137: ["m", 1, "△", "2"],
    // ′7
    1160: ["M", 0, "′", "7"],
    200: ["M", 8, "′", "56"],
    140: ["M", 4, "′", "34"],
    273: ["M", 1, "′", "2"],
    // M9
    586: ["M", 0, "", "9"],
    676: ["M", 8, "", "567"],
    340: ["M", 5, "", "456"],
    298: ["M", 2, "", "234"],
    //658: ["M", 10, "27?"],
    // M▽9  (unconventional symbol)
    585: ["M", 0, "▽", "9"],
    420: ["M", 8, "▽", "567"],
    308: ["M", 5, "▽", "456"],
    294: ["M", 2, "▽", "234"],
    // m9
    582: ["m", 0, "", "9"],
    1352: ["m", 9, "", "567"],
    212: ["m", 5, "", "456"],
    282: ["m", 2, "", "234"],
    //657: ["m", 10, "27?"],
    // m▽9  (unconventional symbol)
    581: ["m", 0, "▽", "9"],
    840: ["m", 9, "▽", "567"],
    180: ["m", 5, "▽", "456"],
    278: ["m", 2, "▽", "234"],
    // ⌀9
    549: ["m", 0, "⌀", "9"],
    836: ["m", 9, "⌀", "567"],
    360: ["m", 6, "⌀", "456"],
    150: ["m", 2, "⌀", "234"],
    // M△9
    1098: ["M", 0, "△", "9"],
    708: ["M", 8, "△", "567"],
    344: ["M", 5, "△", "456"],
    149: ["M", 1, "△", "234"],
    // M⏃9  (unconventional symbol)
    1100: ["M", 0, "⏃", "9"],
    1220: ["M", 8, "⏃", "567"],
    408: ["M", 5, "⏃", "456"],
    153: ["M", 1, "⏃", "234"],
    // ○9
    293: ["m", 0, "○", "9"],
    804: ["m", 9, "○", "567"],
    356: ["m", 6, "○", "456"],
    300: ["m", 3, "○", "234"],
    // m△9
    1094: ["m", 0, "△", "9"],
    1416: ["m", 9, "△", "567"],
    216: ["m", 5, "△", "456"],
    141: ["m", 1, "△", "234"],
    // ′9
    1162: ["M", 0, "′", "9"],
    712: ["M", 8, "′", "567"],
    172: ["M", 4, "′", "456"],
    277: ["M", 1, "′", "234"],
    // 4
    80: ["M", 0, "", "4"],
    66: ["M", 7, "", "25"],
};
    
for (var i in accordo) {
    //accordo[i][2] = '<span>' + accordo[i][2] + '</span>';
    accordo[i][2] = '<i>' + accordo[i][2] + '</i>';
    var n = accordo[i][3];
    var t = "<table>";
    for (var j = n.length - 1; j >= 0 ; j--)
        t += "<tr><td>" + n.charAt(j);
    if (n.length == 1)
        t += "<tr><td>&nbsp;";
    t += "</table>";
    accordo[i][3] = t;
}
